Module javafx.graphics
Package javafx.scene.layout

# Class StackPane

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.layout.Pane
javafx.scene.layout.StackPane

All Implemented Interfaces:
  `Styleable`, `EventTarget`

Direct Known Subclasses:
  `TableHeaderRow`

public class StackPane extends Pane
StackPane lays out its children in a back-to-front stack.

The z-order of the children is defined by the order of the children list with the 0th child being the bottom and last child on top. If a border and/or padding have been set, the children will be laid out within those insets.

The stackpane will attempt to resize each child to fill its content area. If the child could not be sized to fill the stackpane (either because it was not resizable or its max size prevented it) then it will be aligned within the area using the alignment property, which defaults to Pos.CENTER.

StackPane example:

         StackPane stack = new StackPane();
         stack.getChildren().addAll(new Rectangle(100,100,Color.BLUE), new Label("Go!));

StackPane lays out each managed child regardless of the child's visible property value; unmanaged children are ignored.

StackPane may be styled with backgrounds and borders using CSS. See `Region` for details.

## Resizable Range

A stackpane's parent will resize the stackpane within the stackpane's resizable range during layout. By default the stackpane computes this range based on its content as outlined in the table below.

StackPane Resize Table
| width | height
minimum | left/right insets plus the largest of the children's min widths. | top/bottom insets plus the largest of the children's min heights.
preferred | left/right insets plus the largest of the children's pref widths. | top/bottom insets plus the largest of the children's pref heights.
maximum | Double.MAX_VALUE | Double.MAX_VALUE

A stackpane's unbounded maximum width and height are an indication to the parent that it may be resized beyond its preferred size to fill whatever space is assigned to it.

StackPane provides properties for setting the size range directly. These properties default to the sentinel value USE_COMPUTED_SIZE, however the application may set them to other values as needed:

         // ensure stackpane is never resized beyond it's preferred size
         stackpane.setMaxSize(Region.USE_PREF_SIZE, Region.USE_PREF_SIZE);

Applications may restore the computed values by setting these properties back to USE_COMPUTED_SIZE.

StackPane does not clip its content by default, so it is possible that children's bounds may extend outside its own bounds if a child's min size prevents it from being fit within the stackpane.

## Optional Layout Constraints

An application may set constraints on individual children to customize StackPane's layout. For each constraint, StackPane provides a static method for setting it on the child.

StackPane Constraint Table
Constraint | Type | Description
--- | --- | ---
alignment | javafx.geometry.Pos | The alignment of the child within the stackpane.
margin | javafx.geometry.Insets | Margin space around the outside of the child.

Examples:

         // Align the title Label at the bottom-center of the stackpane
         Label title = new Label();
         StackPane.setAlignment(title, Pos.BOTTOM_CENTER);
         stackpane.getChildren.addAll(new ImageView(...), title);

         // Create an 8 pixel margin around a listview in the stackpane
         ListView list = new ListView();
         StackPane.setMargin(list, new Insets(8,8,8,8);
         stackpane.getChildren().add(list);

Since:
  JavaFX 2.0

## Property Summary

Properties
Type
Property
Description
`final ObjectProperty<Pos>`
`alignment`
The default alignment of children within the stackpane's width and height.

### Properties inherited from class javafx.scene.layout.Region

`background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

### Properties inherited from class javafx.scene.Parent

`needsLayout`

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Field Summary

### Fields inherited from class javafx.scene.layout.Region

`USE_COMPUTED_SIZE, USE_PREF_SIZE`

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Constructor
Description
`StackPane()`
Creates a StackPane layout with default CENTER alignment.
`StackPane(Node... children)`
Creates a StackPane layout with default CENTER alignment.

## Method Summary

Modifier and Type
Method
Description
`final ObjectProperty<Pos>`
`alignmentProperty()`
The default alignment of children within the stackpane's width and height.
`static void`
`clearConstraints(Node child)`
Removes all stackpane constraints from the child node.
`protected double`
`computeMinHeight(double width)`
Computes the minimum height of this region.
`protected double`
`computeMinWidth(double height)`
Computes the minimum width of this region.
`protected double`
`computePrefHeight(double width)`
Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy.
`protected double`
`computePrefWidth(double height)`
Computes the preferred width of this region for the given height.
`final Pos`
`getAlignment()`
Gets the value of the `alignment` property.
`static Pos`
`getAlignment(Node child)`
Returns the child's alignment constraint if set.
`static List<CssMetaData<? extends Styleable,?>>`
`getClassCssMetaData()`
`Orientation`
`getContentBias()`
Returns the orientation of a node's resizing bias for layout purposes.
`List<CssMetaData<? extends Styleable,?>>`
`getCssMetaData()`
This method should delegate to `Node.getClassCssMetaData()` so that a Node's CssMetaData can be accessed without the need for reflection.
`static Insets`
`getMargin(Node child)`
Returns the child's margin constraints if set.
`protected void`
`layoutChildren()`
Invoked during the layout pass to layout the children in this `Parent`.
`void`
`requestLayout()`
Requests a layout pass to be performed before the next scene is rendered.
`final void`
`setAlignment(Pos value)`
Sets the value of the `alignment` property.
`static void`
`setAlignment(Node child, Pos value)`
Sets the alignment for the child when contained by a stackpane.
`static void`
`setMargin(Node child, Insets value)`
Sets the margin for the child when contained by a stackpane.

### Methods inherited from class javafx.scene.layout.Pane

`getChildren`

### Methods inherited from class javafx.scene.layout.Region

`backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, computeMaxHeight, computeMaxWidth, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isResizable, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

### Methods inherited from class javafx.scene.Parent

`getBaselineOffset, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, queryAccessibleAttribute, requestParentLayout, setNeedsLayout, updateBounds`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInitialFocusTraversable, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### alignment

public final ObjectProperty<Pos> alignmentProperty
The default alignment of children within the stackpane's width and height. This may be overridden on individual children by setting the child's alignment constraint.

See Also:
  - `getAlignment()`
  - `setAlignment(Pos)`
  - `alignmentProperty()`

## Constructor Details

### StackPane

public StackPane()
Creates a StackPane layout with default CENTER alignment.

### StackPane

public StackPane(Node... children)
Creates a StackPane layout with default CENTER alignment.

Parameters:
  `children` - The initial set of children for this pane.
Since:
  JavaFX 8.0

## Method Details

### setAlignment

public static void setAlignment(Node child, Pos value)
Sets the alignment for the child when contained by a stackpane. If set, will override the stackpane's default alignment. Setting the value to null will remove the constraint.

Parameters:
  `child` - the child node of a stackpane
  `value` - the alignment position for the child

### getAlignment

public static Pos getAlignment(Node child)
Returns the child's alignment constraint if set.

Parameters:
  `child` - the child node of a stackpane
Returns:
  the alignment position for the child or null if no alignment was set

### setMargin

public static void setMargin(Node child, Insets value)
Sets the margin for the child when contained by a stackpane. If set, the stackpane will layout the child with the margin space around it. Setting the value to null will remove the constraint.

Parameters:
  `child` - the child node of a stackpane
  `value` - the margin of space around the child

### getMargin

public static Insets getMargin(Node child)
Returns the child's margin constraints if set.

Parameters:
  `child` - the child node of a stackpane
Returns:
  the margin for the child or null if no margin was set

### clearConstraints

public static void clearConstraints(Node child)
Removes all stackpane constraints from the child node.

Parameters:
  `child` - the child node

### alignmentProperty

public final ObjectProperty<Pos> alignmentProperty()
The default alignment of children within the stackpane's width and height. This may be overridden on individual children by setting the child's alignment constraint.

Returns:
  the alignment of children within this stackpane
See Also:
  - `getAlignment()`
  - `setAlignment(Pos)`

### setAlignment

public final void setAlignment(Pos value)
Sets the value of the `alignment` property.

Property description:
  The default alignment of children within the stackpane's width and height. This may be overridden on individual children by setting the child's alignment constraint.
Parameters:
  `value` - the value for the `alignment` property
See Also:
  - `getAlignment()`
  - `alignmentProperty()`

### getAlignment

public final Pos getAlignment()
Gets the value of the `alignment` property.

Property description:
  The default alignment of children within the stackpane's width and height. This may be overridden on individual children by setting the child's alignment constraint.
Returns:
  the value of the `alignment` property
See Also:
  - `setAlignment(Pos)`
  - `alignmentProperty()`

### getContentBias

public Orientation getContentBias()
Description copied from class: `Node`
Returns the orientation of a node's resizing bias for layout purposes. If the node type has no bias, returns null. If the node is resizable and it's height depends on its width, returns HORIZONTAL, else if its width depends on its height, returns VERTICAL.

Resizable subclasses should override this method to return an appropriate value.

Overrides:
  `getContentBias` in class `Node`
Returns:
  the first non-null contentBias of its managed children or null if no managed children have a content bias.
See Also:
  - `Node.isResizable()`
  - `Node.minWidth(double)`
  - `Node.minHeight(double)`
  - `Node.prefWidth(double)`
  - `Node.prefHeight(double)`
  - `Node.maxWidth(double)`
  - `Node.maxHeight(double)`

### computeMinWidth

protected double computeMinWidth(double height)
Description copied from class: `Region`
Computes the minimum width of this region. Returns the sum of the left and right insets by default. region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.

Overrides:
  `computeMinWidth` in class `Region`
Parameters:
  `height` - the height that should be used if min width depends on it
Returns:
  the computed minimum width of this region

### computeMinHeight

protected double computeMinHeight(double width)
Description copied from class: `Region`
Computes the minimum height of this region. Returns the sum of the top and bottom insets by default. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.

Overrides:
  `computeMinHeight` in class `Region`
Parameters:
  `width` - the width that should be used if min height depends on it
Returns:
  the computed minimum height for this region

### computePrefWidth

protected double computePrefWidth(double height)
Description copied from class: `Region`
Computes the preferred width of this region for the given height. Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a VERTICAL content bias, then the height parameter can be ignored.

Overrides:
  `computePrefWidth` in class `Region`
Parameters:
  `height` - the height that should be used if preferred width depends on it
Returns:
  the computed preferred width for this region

### computePrefHeight

protected double computePrefHeight(double width)
Description copied from class: `Region`
Computes the preferred height of this region for the given width; Region subclasses should override this method to return an appropriate value based on their content and layout strategy. If the subclass doesn't have a HORIZONTAL content bias, then the width parameter can be ignored.

Overrides:
  `computePrefHeight` in class `Region`
Parameters:
  `width` - the width that should be used if preferred height depends on it
Returns:
  the computed preferred height for this region

### requestLayout

public void requestLayout()
Description copied from class: `Parent`
Requests a layout pass to be performed before the next scene is rendered. This is batched up asynchronously to happen once per "pulse", or frame of animation.

If this parent is either a layout root or unmanaged, then it will be added directly to the scene's dirty layout list, otherwise requestParentLayout will be invoked.

Overrides:
  `requestLayout` in class `Parent`

### layoutChildren

protected void layoutChildren()
Description copied from class: `Parent`
Invoked during the layout pass to layout the children in this `Parent`. By default it will only set the size of managed, resizable content to their preferred sizes and does not do any node positioning.

Subclasses should override this function to layout content as needed.

Overrides:
  `layoutChildren` in class `Parent`

### getClassCssMetaData

public static List<CssMetaData<? extends Styleable,?>> getClassCssMetaData()

Returns:
  The CssMetaData associated with this class, which may include the CssMetaData of its superclasses.
Since:
  JavaFX 8.0

### getCssMetaData

public List<CssMetaData<? extends Styleable,?>> getCssMetaData()
This method should delegate to `Node.getClassCssMetaData()` so that a Node's CssMetaData can be accessed without the need for reflection.

Specified by:
  `getCssMetaData` in interface `Styleable`
Overrides:
  `getCssMetaData` in class `Region`
Returns:
  The CssMetaData associated with this node, which may include the CssMetaData of its superclasses.
Since:
  JavaFX 8.0